Page MenuHomePhabricator

Disable Phabricator comment hiding/collapsing
Closed, DeclinedPublic

Description

Upstream ticket: https://secure.phabricator.com/T6400

When I go to T43, it reads 75 older changes are hidden. Show all changes.. This makes in-browser find difficult and requires me to click a link in order to see the full task. We should either make this comment hiding/collapsing configurable per-user or simply disable it across the site. Hiding/collapsing comments directly hinders and harms user-to-user communication and results in wasted time as people make duplicative comments.

Event Timeline

MZMcBride raised the priority of this task from to Needs Triage.
MZMcBride updated the task description. (Show Details)
MZMcBride added a project: Phabricator.
MZMcBride changed Security from none to None.
MZMcBride added a subscriber: Nemo_bis.
MZMcBride added a subscriber: MZMcBride.
Qgil triaged this task as Lowest priority.Oct 26 2014, 3:16 AM
Qgil edited projects, added Phabricator (Upstream); removed Phabricator.
Qgil added a subscriber: Qgil.

The first time you visit a page you see it always at full length. In future visits, and when the pages are long, you will get the history you have (theoretically) read collapsed.

Aklapper updated the task description. (Show Details)

I actually like it and think it makes the UI better.

Qgil awarded a token.Oct 27 2014, 4:55 PM
Qgil added a comment.Oct 27 2014, 4:57 PM

In order to save the user a click if they want to see all the comments, we would be forcing everyone to scroll down in long ongoing discussions, every time they would access to the same page.

Not a good trade, in my opinion.

Aklapper closed this task as Declined.Oct 27 2014, 7:28 PM
Aklapper claimed this task.

Upstream reply, closed as WONTFIX:

we only collapse after (technically, right before) your most recent action, not by default. The theory is that if you've acted on an object you usually have already read everything above your action, and you can review your most recent action for a reminder of where things left off.
In practice, this seems to be a widely reasonable heuristic and all or nearly-all feedback we've received about this feature has been positive, I think.
It's possible that we might want to disable this rule for specific types of actions (for example, maybe just a CC or just a mention or something shouldn't trigger the collapse), but it looks like the use case in the attached ticket was a comment.
For the overwhelming majority of users, auto-collapsing before the user's most recent comment seems to be a desirable feature, so we don't plan to remove this or make it optional.
(After https://secure.phabricator.com/T4712, we will collapse by default for very large transaction sets, but the minimum cutoff will probably be something like 100 or 200 items.)

I generally agree with the concerns raised in this task's description. Collapsing often has more negative consequences than it has benefits, for something as potentially important as "all prior discussion about a task/bug".
If there are (eg.) 50 prior comments, it's often a good idea to re-read them the next time one visits, especially if it's a few weeks/months/years later.
It's good to encourage skimming of old content, and remembering previous concerns, and other perspectives and suggestions.
It's an "Understand history, or be doomed to repeating it" kind of thing.

This is especially the case for the people with a "quick slapdash comment" style of interaction (and less of an issue for the slow and methodical heavy-previewers and fact-checkers). Having the "reply by email" option turned on will probably also exacerbate this issue.

It's also slightly discouraging, to think that my detailed and well-edited comments, that frequently collate a bunch of useful information, are vastly less likely to be seen a second time once someone has commented (assuming they read or skimmed the whole thread initially).

If a preference was available, I would definitely switch it on for myself, and I would probably urge making it the default setup. I use ctrl-F, and reread old comments, a lot, and I wish many other people did both more frequently.

However, I do understand the benefits of collapsing: if gmail/thunderbird/etc didn't collapse old emails in a thread, that would be annoying. On the other hand, the content/style of emails is quite different than the history of actions and comments in a bug/task tracker.

So:

  • I very strongly encourage the upstream suggestion of "disable this rule for specific types of actions (for example, maybe just a CC or just a mention or something shouldn't trigger the collapse)"
  • I'd also suggest a time-based expansion, be requested upstream: e.g. "If I haven't seen a Task in 3 months, then all previous changes should be expanded."
  • I also encourage re-examining this bug in the months to come.
  • And I've filed T962 ("Increase the clickable region of the "Show all changes" expand box.") which should partially ease the problems in the meantime. (hopefully that's fixable at our level, or accepted upstream).
Qgil added a comment.Oct 29 2014, 8:43 AM

I think it is too soon to make any solid evaluation of this feature. We are used to Bugzilla, where comments are very valuable because that is all the interaction that it is allowed. I we are good Phabricator contributors, long discussions should bring edits to the task description, which would summarize always the information that really matters to resolve the task discussed.

Anyway, it's just a click away.

I just hit this issue again. The crippling effect that the collapsing has on in-browser find is pretty bad, in my opinion.

@Jaredzimmerman-WMF just mentioned this in T56307#843262 and it's still regularly aggravating me. Just noting for now.

I understand why it exists, but It keeps making me look foolish ( same thing happens on facebook when they do the same thing)

I wish phab was top posting (like Trello) instead of bottom posting, seems like it would solve for @Qgil's scrolling issue.

I wish phab was top posting (like Trello) instead of bottom posting, seems like it would solve for @Qgil's scrolling issue.

That makes it even more unlikely that people would read historical comments, so there'd be wide objections. We heartily discourage "just reading the task, and replying without reading any of the intervening comments". For precisely the reasons that I mentioned in my comment.

@Quiddity I think having them searchable and non-collapsed would improve matters even if the post order was reversed.

jeremyb added a subscriber: jeremyb.Jan 7 2015, 5:00 AM

Worse: at https://web.archive.org/web/20160412223158/https://phabricator.wikimedia.org/T43 I can't see the entire content unless I load resources from the live Phabricator.

Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptMay 18 2016, 9:09 PM

Can someone help me/us by writing a greasemonkey script, to autoexpand?
This seems to be the relevant source, but I'm unsure how to trigger it?

<div class="phui-timeline-older-transactions-are-hidden" data-sigil="show-older-block">Changes from before your most recent comment are hidden. <a href="/transactions/showolder/PHID-TASK-ncr625y4uej4vbgih5vy/?after=844599&amp;quoteTargetID=UQ0_11&amp;quoteRef=T912" data-mustcapture="1" data-sigil="show-older-link">Show Older Changes</a></div>


Just in case it's relevant/useful... I use this code in my global.js to autoexpand some collapsed sections onwiki, but I don't know if it can be adapted?

// Expand all grouped RC/Watchlist entries. Thanks to [[m:User:PiRSquared17]].
$(window).load(function() { $('.mw-enhancedchanges-arrow').click(); });

and

// Default expand the "View templates on this page" and "View hidden categories on this page" on initial preview
document.cookie='templates-used-list=expanded';
document.cookie='hiddencats-list=expanded';

Qgil removed a subscriber: Qgil.Apr 20 2017, 9:34 AM